/**************************************************************************
 *                                                                        *
 *               Copyright (C) 1997, Dynamix, Inc.                        *
 *                                                                        *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Dynamix, Inc.,  and are      *
 *  protected by Federal copyright  law.  They  may not be disclosed to   *
 *  third parties  or copied or duplicated in any form, in whole or       *
 *  in part, without the prior written consent of Dynamix, Inc.           *
 *                                                                        *
 *************************************************************************/

#include <ultra64.h>
#include "scroller.h"



static char scrolltext[] = "\
hiya and welcome to the first dynamix demo on the nintendo 64 !!!    \
since this is our first release we'd like to introduce ourselves.   \
currently dynamix consists of two members: immortal and widget.        \
\
you are probably wondering why we choose the name 'dynamix', besides \
the fact that the name has a nice ring to it, it has been a very cool \
group in pc scene with people like bluewater, razor sharp, hoson etc... \
\
as some of you may know this demo has been delayed some weeks. we don't \
wanna bore you with details but besides lack of time and stupid typo's. \
it's mostly due to the doc64 lack of quality. widget's doc currently has a \
corrupt memory module and a exploded power supply. so he'll probably won't \
see the final version of this demo till next week. 'long live vd64' my ass. \
still it's the best equipement for developping, let's wait and see what the \
z64 can do.          \
\
it's time for demo credits: immortal coded the 3d object part and the \
gl2c convertor, widget coded the 2d sprite part and ppm2c convertor. \
and featuring as guest coder we have lac !!! he coded and let us use lacmod !!! \
the s3m module you are listening to is called 'ode 2 jodie sweetin' and is composed by cygnes.         \
\
ok ok ok. it's time for the greetings and hello's, all in non-logical order: \
lac,stan,twinnie,locke,nagra,jovis,jihad,uxorious,fractal,datawiz,\
oman,silo,kidstardust,rene,sispeo,titanik,wildfire,steve,fusionman,\
stumble,tazdevil,speedy-g,wizard,rip,conmango,superdoc,matzer,nil,\
fredro and ofcoz lac hehehehe..         \
\
that's all for this introduction, if you wanna contact us, join n64dev \
on efnet irc.                                 wrap                    ";


/*
 *
 * List of available characters, index in this string corresponds with
 * structure in letters_bms
 *
 */

static char letters_str[] = "abcdefghijklmnopqrstuvwxyz0123456789.,:!?-'";

/*
 *
 * Letter structure for letter-specific size and bitmap pointer
 *
 */

static Bitmap letters_bms[] = {
        { 31, 32, 0, 0, font_a, 32, 0 },
        { 31, 32, 0, 0, font_b, 32, 0 },
        { 31, 32, 0, 0, font_c, 32, 0 },
        { 31, 32, 0, 0, font_d, 32, 0 },
        { 31, 32, 0, 0, font_e, 32, 0 },
        { 31, 32, 0, 0, font_f, 32, 0 },
        { 31, 32, 0, 0, font_g, 32, 0 },
        { 31, 32, 0, 0, font_h, 32, 0 },
        { 31, 32, 0, 0, font_i, 32, 0 },
        { 31, 32, 0, 0, font_j, 32, 0 },
        { 31, 32, 0, 0, font_k, 32, 0 },
        { 31, 32, 0, 0, font_l, 32, 0 },
        { 31, 32, 0, 0, font_m, 32, 0 },
        { 31, 32, 0, 0, font_n, 32, 0 },
        { 31, 32, 0, 0, font_o, 32, 0 },
        { 31, 32, 0, 0, font_p, 32, 0 },
        { 31, 32, 0, 0, font_q, 32, 0 },
        { 31, 32, 0, 0, font_r, 32, 0 },
        { 31, 32, 0, 0, font_s, 32, 0 },
        { 31, 32, 0, 0, font_t, 32, 0 },
        { 31, 32, 0, 0, font_u, 32, 0 },
        { 31, 32, 0, 0, font_v, 32, 0 },
        { 31, 32, 0, 0, font_w, 32, 0 },
        { 31, 32, 0, 0, font_x, 32, 0 },
        { 31, 32, 0, 0, font_y, 32, 0 },
        { 31, 32, 0, 0, font_z, 32, 0 },

        { 31, 32, 0, 0, font_0, 32, 0 },
        { 31, 32, 0, 0, font_1, 32, 0 },
        { 31, 32, 0, 0, font_2, 32, 0 },
        { 31, 32, 0, 0, font_3, 32, 0 },
        { 31, 32, 0, 0, font_4, 32, 0 },
        { 31, 32, 0, 0, font_5, 32, 0 },
        { 31, 32, 0, 0, font_6, 32, 0 },
        { 31, 32, 0, 0, font_7, 32, 0 },
        { 31, 32, 0, 0, font_8, 32, 0 },
        { 31, 32, 0, 0, font_9, 32, 0 },

        { 10, 12, 0, 0, font_dot,      32, 0 },
        { 10, 12, 0, 0, font_comma,    32, 0 },
        { 10, 12, 0, 0, font_colon,    32, 0 },
        { 10, 12, 0, 0, font_exclam,   32, 0 },
        { 31, 32, 0, 0, font_question, 32, 0 },
        { 31, 32, 0, 0, font_dash,     32, 0 },
        { 10, 12, 0, 0, font_quote,    32, 0 }
};


/*
 *
 * Sprite structure and definitions for scroller
 *
 * Note: the number of NUM_SCROLLER_ITEMS needs some 'fune'-tuning.
 *       Seems the SP code needs some extra dl space then macro NUM_DL
 *       calculated but this is already mentioned in SP.H
 *
 */

ScrollerItem scrollerArray[NUM_SCROLLER_ITEMS];
Gfx          scroller_dl[NUM_DL(NUM_SCROLLER_ITEMS)];

Sprite scroller_sprite = {
 0,0,                   /* position: x,y */
 0,0,                   /* sprite size in texels: x,y */
 0,0,                   /* sprite scale: x,y */
 0,0,                   /* explosion: x,y */
 3,                     /* attribute: just copy :) */
 0x1234,                /* sprite depth: z */
 255,255,255,255,       /* sprite coloration RGBA */
 0,0,NULL,              /* color lookup table: start_index, length, address */
 0,1,                   /* sprite bitmap index: start_index, increment */
 NUM_SCROLLER_BM,       /* number of bitmaps */
 NUM_DL(NUM_SCROLLER_BM), /* number of dl locations allocated */
 0,0,                   /* sprite bitmap height: used_height, physical height */
 G_IM_FMT_RGBA,         /* sprite bitmap format */
 G_IM_SIZ_16b,          /* sprite bitmap texel size */
 NULL,                  /* pointer to bitmaps */
 scroller_dl,           /* rsp_dl: display list memory */
 NULL,                  /* rsp_next_dl: dynamic_dl pointer */
 0,0                    /* texture fractional offsets */
};


/*
 *
 * Global variables definitions for the scroller procedures
 *
 */

s16     scrollSpacer = 0;
u16     scrollPointer = 0;



char *my_strchr(char *str, char target)
{
   while(*str && (*str != target))
      str++;

   if (*str)
      return(str);

   return(NULL);
      
}

scrollerInit(void)
{
   int n;

   for(n=0;n<NUM_SCROLLER_ITEMS;n++)
      scrollerArray[n].active = 0;

}

drawScroller(Gfx **glistp)
{
  Gfx    *gxp = *glistp;
  Gfx    *dl;
  Sprite *sp  = &scroller_sprite;
  int    n;

  sp->rsp_dl = scroller_dl;
  sp->rsp_dl_next = NULL;


  for(n=0;n<NUM_SCROLLER_ITEMS;n++) {
     if (scrollerArray[n].active == 1) {

        ScrollerItem *p = &scrollerArray[n];

        sp->x            = p->x;
        sp->y            = p->y;
        sp->width        = p->width;
        sp->height       = p->height;
        sp->bmheight     = p->height;
        sp->bmHreal      = p->height;
        sp->bitmap       = p->bitmap;

        spScale(sp, FONT_SCALE_X, FONT_SCALE_Y);

        dl = spDraw(sp);
        gSPDisplayList(gxp++, dl);

     }
  }

  *glistp = gxp;

}

s16 addLetterToScroller(void)
{
   int n;

   for(n=0;n<NUM_SCROLLER_ITEMS;n++) {
      if (scrollerArray[n].active == 0) {

         Bitmap       *bm;
         ScrollerItem *p = &scrollerArray[n];
         char         *c = &scrolltext[scrollPointer++];
         char         *Index;

         if (*c == '\0') {
                scrollPointer = 0;
                c = &scrolltext[scrollPointer++];
         }

         if (*c == ' ')
            return((u16) (SPACE_WIDTH / SCROLL_STEP) );


         if ((Index = my_strchr(letters_str, *c)) != NULL) {

            bm = &letters_bms[Index - letters_str];
            p->x          = 320;
            p->y          = 200;
            p->original_y = 200;
            p->width      = bm->width;
            p->height     = bm->actualHeight;
            p->bitmap     = bm;
            p->active     = 1;

         }

         return((u16) ((bm->width * FONT_SCALE_X + SPACER) / SCROLL_STEP) );

      }
   }

   return (1);

}

doScroll(f32 moveCnt)
{
   int n;
   ScrollerItem *p;

   for(n=0;n<NUM_SCROLLER_ITEMS;n++) {
      if (scrollerArray[n].active == 1) {

         p = &scrollerArray[n];

         p->y = p->original_y + sinf((p->x - moveCnt/1.6)/20)*7;
         p->x -= SCROLL_STEP;
         if (p->x + p->width * FONT_SCALE_X < 0)
            p->active = 0;
      }
   }

}
